{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.View.Control.Post where

-- env
import Bamboo.Helper.Env

import qualified Bamboo.Type.State as State
import qualified Bamboo.Config.Global as G

import Bamboo.Type.Extension
import Bamboo.Helper.StateHelper

-- model
import qualified Bamboo.Model.Comment as Comment
import Bamboo.View.Atom.Post
import Bamboo.Model.Post

-- view
import Bamboo.View.Control.Helper
import qualified Bamboo.View.Control.Comment as CommentV
import Bamboo.View.Widget.Template

-- entry view
view :: State.State -> [Comment.Comment] -> Post -> Html
view state xs x = (x.render_data +++ comment_view ).page state
  where comment_view = only_for Comment $ CommentV.list xs +++ CommentV.create state (x.uid.Comment.from_post_id)

-- list view
list state = map render > p_eval' > (+++ nav p G.root) > page state where 
  p = state.State.pager
  render = render_summary G.summary_for_root
